// (c) 2005 Ryabinin S. 
// freeware
// precise sleep realisation class

/*	example:
MMTimer.Resolution = 0;	// max possible timer resolution
MMTimer.Sleep(1);	// on my Pentium 4 3GHz - 1.5 milliseconds, so error not exceed 0.5 ms
*/

#ifndef SlaMMTimerH
#define SlaMMTimerH

//---------------------------------------------------------------------------

#include <windows.h>
#include <mmsystem.h>

#define EMERGENCY_TIME		(10000)	// time for semaphore wait function (ms)

//---------------------------------------------------------------------------

class SlaMMTimer
    {
	private:

	protected:
    MMRESULT TimerID;

	public:
    __fastcall SlaMMTimer();
    __fastcall ~SlaMMTimer();

    HANDLE Semaphore;
    int Resolution;

    bool __fastcall Sleep(int MilliSeconds);
    };

//---------------------------------------------------------------------------

extern SlaMMTimer MMTimer;

//---------------------------------------------------------------------------

#endif // SlaMMTimerH
