// (c) 2005 Ryabinin S. 
// freeware
//---------------------------------------------------------------------------

#include "SlaMMTimer.h"

//---------------------------------------------------------------------------

static void CALLBACK TimerCallBack(unsigned int uID, unsigned int uMsg, DWORD dwUser, DWORD dw1, DWORD dw2);

//---------------------------------------------------------------------------

void CALLBACK TimerCallBack(unsigned int uID, unsigned int uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
    {
    ReleaseSemaphore(MMTimer.Semaphore, 1, NULL);
    };

//---------------------------------------------------------------------------

__fastcall SlaMMTimer::SlaMMTimer()
    {
    Semaphore = CreateSemaphore(NULL, 0x00, 0x01, "MMTimerSem" );
    Resolution = 1;
    };

//---------------------------------------------------------------------------

__fastcall SlaMMTimer::~SlaMMTimer()
    {
    CloseHandle(Semaphore);
    };

//---------------------------------------------------------------------------

bool __fastcall SlaMMTimer::Sleep(int MilliSeconds)
    {
    TimerID = timeSetEvent(MilliSeconds, Resolution, TimerCallBack, NULL, TIME_ONESHOT);

    if ( TimerID )
        {
        WaitForSingleObject(Semaphore, EMERGENCY_TIME);

        timeKillEvent( TimerID );

        return true;
        }

    return false;
    };

//---------------------------------------------------------------------------

SlaMMTimer MMTimer;

//---------------------------------------------------------------------------

